Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 11439)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 11440)
@@ -78,5 +78,5 @@
 #if defined key_dynldf_c3d
          IF( kt == nit000 .AND. ln_stopack .AND. &
-            & ( (nn_spp_ahm1+nn_spp_ahm2) > 0 ) ) THEN
+            & ( (nn_spp_ahm1 + nn_spp_ahm2) > 0 ) ) THEN
              ALLOCATE ( ahm10(jpi,jpj,jpk), ahm20(jpi,jpj,jpk) )
              ALLOCATE ( ahm30(jpi,jpj,jpk), ahm40(jpi,jpj,jpk) )
@@ -89,5 +89,5 @@
 #if defined key_dynldf_c2d
          IF( kt == nit000 .AND. ln_stopack .AND. &
-            & ( (nn_spp_ahm1+nn_spp_ahm2) > 0 ) ) THEN
+            & ( (nn_spp_ahm1 + nn_spp_ahm2) > 0 ) ) THEN
              ALLOCATE ( ahm10(jpi,jpj), ahm20(jpi,jpj) )
              ALLOCATE ( ahm30(jpi,jpj), ahm40(jpi,jpj) )
@@ -104,9 +104,9 @@
                IF( ln_dynldf_lap ) THEN
                   ahm1 = ahm10
-                  CALL spp_ahm(kt,ahm1,nn_spp_ahm1,rn_ahm1_sd,jk_spp_ahm1)
+                  CALL spp_ahm(kt, ahm1, nn_spp_ahm1, rn_ahm1_sd, jk_spp_ahm1)
                ENDIF
                IF( ln_dynldf_bilap ) THEN
                   ahm3 = ahm30
-                  CALL spp_ahm(kt,ahm3,nn_spp_ahm1,rn_ahm1_sd,jk_spp_ahm3)
+                  CALL spp_ahm(kt, ahm3, nn_spp_ahm1, rn_ahm1_sd, jk_spp_ahm3)
                ENDIF
             ENDIF
@@ -114,9 +114,9 @@
                IF( ln_dynldf_lap ) THEN
                ahm2 = ahm20
-               CALL spp_ahm(kt,ahm2,nn_spp_ahm2,rn_ahm2_sd,jk_spp_ahm2)
+               CALL spp_ahm(kt, ahm2, nn_spp_ahm2, rn_ahm2_sd, jk_spp_ahm2)
                ENDIF
                IF( ln_dynldf_bilap ) THEN
                   ahm4 = ahm40
-                  CALL spp_ahm(kt,ahm4,nn_spp_ahm2,rn_ahm2_sd,jk_spp_ahm4)
+                  CALL spp_ahm(kt, ahm4, nn_spp_ahm2, rn_ahm2_sd, jk_spp_ahm4)
                ENDIF
             ENDIF
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 11439)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 11440)
@@ -98,9 +98,9 @@
             IF( nn_sstr == 1 ) THEN                                   !* Temperature restoring term
 
-               CALL wrk_alloc( jpi, jpj, rn_dqdt_s)
+               CALL wrk_alloc( jpi, jpj, rn_dqdt_s )
                rn_dqdt_s(:,:) = rn_dqdt
 
                IF( ln_stopack .AND. nn_spp_dqdt > 0 ) &
-                  & CALL spp_gen(kt, rn_dqdt_s,nn_spp_dqdt,rn_dqdt_sd,jk_spp_dqdt )
+                  & CALL spp_gen( kt, rn_dqdt_s, nn_spp_dqdt, rn_dqdt_sd, jk_spp_dqdt )
                DO jj = 1, jpj
                   DO ji = 1, jpi
@@ -135,5 +135,5 @@
                zsrp(:,:) = rn_deds
                IF( ln_stopack .AND. nn_spp_dedt > 0 ) &
-                  & CALL spp_gen(kt, zsrp, nn_spp_dedt, rn_dedt_sd, jk_spp_deds )
+                  & CALL spp_gen( kt, zsrp, nn_spp_dedt, rn_dedt_sd, jk_spp_deds )
                zerp_bnd = rn_sssr_bnd / rday                          !       -              -    
 !CDIR COLLAPSE
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/STO/stopack.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/STO/stopack.F90	(revision 11439)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/STO/stopack.F90	(revision 11440)
@@ -2246,16 +2246,10 @@
       IF (ln_dpsiu ) THEN
           CALL lbc_lnk(dpsiu,'T',1._wp)
-#ifdef key_iomput
-          !CALL iom_put( "bsft" , dpsiu )
-#endif
       ENDIF
       IF (ln_dpsiv ) THEN
           CALL lbc_lnk(dpsiv,'T',1._wp)
-#ifdef key_iomput
-          !CALL iom_put( "bsftv" , dpsiv )
-#endif
-      ENDIF
-
-      IF(kt .EQ. nitend ) THEN
+      ENDIF
+
+      IF(kt == nitend ) THEN
         IF (ln_dpsiv ) DEALLOCATE ( dpsiv )
         IF (ln_dpsiu ) DEALLOCATE ( dpsiu )
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 11439)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 11440)
@@ -200,9 +200,9 @@
       ahu_bbl_1(:,:) = ahu_bbl(:,:)
       IF( ln_stopack .AND. nn_spp_ahubbl > 0 ) THEN
-          CALL spp_gen(1 , ahu_bbl_1, nn_spp_ahubbl, rn_ahubbl_sd, jk_spp_ahubbl )
+          CALL spp_gen(1, ahu_bbl_1, nn_spp_ahubbl, rn_ahubbl_sd, jk_spp_ahubbl )
       ENDIF
       ahv_bbl_1(:,:) = ahv_bbl(:,:)
       IF( ln_stopack .AND. nn_spp_ahvbbl > 0 ) THEN
-          CALL spp_gen(1 , ahv_bbl_1, nn_spp_ahvbbl, rn_ahvbbl_sd, jk_spp_ahvbbl )
+          CALL spp_gen(1, ahv_bbl_1, nn_spp_ahvbbl, rn_ahvbbl_sd, jk_spp_ahvbbl )
       ENDIF
       !
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90	(revision 11439)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90	(revision 11440)
@@ -808,6 +808,6 @@
          END DO
          IF( ln_stopack) THEN
-            IF( nn_spp_avt > 0 ) CALL spp_gen(kt,avt(:,:,jk),nn_spp_avt,rn_avt_sd,jk)
-            IF( nn_spp_avm > 0 ) CALL spp_gen(kt,avm(:,:,jk),nn_spp_avm,rn_avm_sd,jk)
+            IF( nn_spp_avt > 0 ) CALL spp_gen(kt, avt(:,:,jk), nn_spp_avt, rn_avt_sd,jk)
+            IF( nn_spp_avm > 0 ) CALL spp_gen(kt, avm(:,:,jk), nn_spp_avm, rn_avm_sd,jk)
          ENDIF 
       END DO
Index: /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 11439)
+++ /branches/UKMO/dev_r5518_GO6_package_FOAMv14_STOPACK/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 11440)
@@ -189,21 +189,21 @@
          IF( nn_spp_tkelc > 0 ) THEN
              rn_lc0 = rn_lc
-             CALL spp_gen(kt,rn_lc0,nn_spp_tkelc,rn_tkelc_sd,    jk_spp_tkelc )
+             CALL spp_gen( kt, rn_lc0, nn_spp_tkelc, rn_tkelc_sd, k_spp_tkelc )
          ENDIF
          IF( nn_spp_tkedf > 0 ) THEN
              rn_ediff0 = rn_ediff
-             CALL spp_gen(kt,rn_ediff0,nn_spp_tkedf,rn_tkedf_sd, jk_spp_tkedf )
+             CALL spp_gen( kt,r n_ediff0, nn_spp_tkedf, rn_tkedf_sd, jk_spp_tkedf )
          ENDIF
          IF( nn_spp_tkeds > 0 ) THEN
              rn_ediss0 = rn_ediss
-             CALL spp_gen(kt,rn_ediss0,nn_spp_tkeds,rn_tkeds_sd, jk_spp_tkeds )
+             CALL spp_gen( kt, rn_ediss0, nn_spp_tkeds, rn_tkeds_sd, jk_spp_tkeds )
          ENDIF
          IF( nn_spp_tkebb > 0 ) THEN
              rn_ebb0 = rn_ebb
-             CALL spp_gen(kt,rn_ebb0,nn_spp_tkebb,rn_tkebb_sd,   jk_spp_tkebb )
+             CALL spp_gen( kt, rn_ebb0, nn_spp_tkebb, rn_tkebb_sd, jk_spp_tkebb )
         ENDIF
          IF( nn_spp_tkefr > 0 ) THEN
              rn_efr0 = rn_efr
-             CALL spp_gen(kt,rn_efr0,nn_spp_tkefr,rn_tkefr_sd,   jk_spp_tkefr )
+             CALL spp_gen( kt, rn_efr0, nn_spp_tkefr, rn_tkefr_sd, jk_spp_tkefr )
          ENDIF
       ENDIF
@@ -739,6 +739,6 @@
          END DO
          IF( ln_stopack) THEN
-            IF(nn_spp_avt > 0 ) CALL spp_gen(1 ,avt(:,:,jk),nn_spp_avt,rn_avt_sd, jk_spp_avt, jk)
-            IF(nn_spp_avm > 0 ) CALL spp_gen(1 ,avm(:,:,jk),nn_spp_avm,rn_avm_sd, jk_spp_avm, jk)
+            IF(nn_spp_avt > 0 ) CALL spp_gen( 1, avt(:,:,jk), nn_spp_avt, rn_avt_sd, jk_spp_avt, jk)
+            IF(nn_spp_avm > 0 ) CALL spp_gen( 1, avm(:,:,jk), nn_spp_avm, rn_avm_sd, jk_spp_avm, jk)
          ENDIF
       END DO