Index: NEMO/trunk/doc/latex/NEMO/subfiles/chap_TRA.tex
===================================================================
--- NEMO/trunk/doc/latex/NEMO/subfiles/chap_TRA.tex	(revision 11445)
+++ NEMO/trunk/doc/latex/NEMO/subfiles/chap_TRA.tex	(revision 11459)
@@ -48,8 +48,7 @@
 associated modules \mdl{eosbn2} and \mdl{phycst}).
 
-The different options available to the user are managed by namelist logicals or CPP keys.
+The different options available to the user are managed by namelist logicals.
 For each equation term \textit{TTT}, the namelist logicals are \textit{ln\_traTTT\_xxx},
 where \textit{xxx} is a 3 or 4 letter acronym corresponding to each optional scheme.
-%The CPP key (when it exists) is \key{traTTT}.
 The equivalent code can be found in the \textit{traTTT} or \textit{traTTT\_xxx} module,
 in the \path{./src/OCE/TRA} directory.
@@ -69,5 +68,5 @@
 %-------------------------------------------------------------------------------------------------------------
 
-When considered (\ie\ when \np{ln\_traadv\_NONE} is not set to \forcode{.true.}),
+When considered (\ie\ when \np{ln\_traadv\_OFF} is not set to \forcode{.true.}),
 the advection tendency of a tracer is expressed in flux form,
 \ie\ as the divergence of the advective fluxes.
@@ -140,5 +139,5 @@
 two quantities that are not correlated \citep{roullet.madec_JGR00, griffies.pacanowski.ea_MWR01, campin.adcroft.ea_OM04}.
 
-The velocity field that appears in (\autoref{eq:tra_adv} and \autoref{eq:tra_adv_zco?}) is
+The velocity field that appears in (\autoref{eq:tra_adv} is 
 the centred (\textit{now}) \textit{effective} ocean velocity, \ie\ the \textit{eulerian} velocity
 (see \autoref{chap:DYN}) plus the eddy induced velocity (\textit{eiv}) and/or
@@ -287,11 +286,4 @@
 A comparison of FCT-2 with MUSCL and a MPDATA scheme can be found in \citet{levy.estublier.ea_GRL01}.
 
-An additional option has been added controlled by \np{nn\_fct\_zts}.
-By setting this integer to a value larger than zero,
-a $2^{nd}$ order FCT scheme is used on both horizontal and vertical direction, but on the latter,
-a split-explicit time stepping is used, with a number of sub-timestep equals to \np{nn\_fct\_zts}.
-This option can be useful when the size of the timestep is limited by vertical advection \citep{lemarie.debreu.ea_OM15}.
-Note that in this case, a similar split-explicit time stepping should be used on vertical advection of momentum to
-insure a better stability (see \autoref{subsec:DYN_zad}).
 
 For stability reasons (see \autoref{chap:STP}),
@@ -375,5 +367,5 @@
 \citep{shchepetkin.mcwilliams_OM05, demange_phd14}.
 Therefore the vertical flux is evaluated using either a $2^nd$ order FCT scheme or a $4^th$ order COMPACT scheme
-(\np{nn\_cen\_v}\forcode{ = 2 or 4}).
+(\np{nn\_ubs\_v}\forcode{ = 2 or 4}).
 
 For stability reasons (see \autoref{chap:STP}), the first term  in \autoref{eq:tra_adv_ubs}
@@ -467,6 +459,6 @@
 %        Type of operator
 % -------------------------------------------------------------------------------------------------------------
-\subsection[Type of operator (\texttt{ln\_traldf}\{\texttt{\_NONE,\_lap,\_blp}\})]
-{Type of operator (\protect\np{ln\_traldf\_NONE}, \protect\np{ln\_traldf\_lap}, or \protect\np{ln\_traldf\_blp}) }
+\subsection[Type of operator (\texttt{ln\_traldf}\{\texttt{\_OFF,\_lap,\_blp}\})]
+{Type of operator (\protect\np{ln\_traldf\_OFF}, \protect\np{ln\_traldf\_lap}, or \protect\np{ln\_traldf\_blp}) }
 \label{subsec:TRA_ldf_op}
 
@@ -474,5 +466,5 @@
 
 \begin{description}
-\item[\np{ln\_traldf\_NONE}\forcode{ = .true.}:]
+\item[\np{ln\_traldf\_OFF}\forcode{ = .true.}:]
   no operator selected, the lateral diffusive tendency will not be applied to the tracer equation.
   This option can be used when the selected advection scheme is diffusive enough (MUSCL scheme for example).
@@ -542,9 +534,9 @@
 where zero diffusive fluxes is assumed across solid boundaries,
 first (and third in bilaplacian case) horizontal tracer derivative are masked.
-It is implemented in the \rou{traldf\_lap} subroutine found in the \mdl{traldf\_lap} module.
-The module also contains \rou{traldf\_blp}, the subroutine calling twice \rou{traldf\_lap} in order to
+It is implemented in the \rou{tra\_ldf\_lap} subroutine found in the \mdl{traldf\_lap\_blp}} module.
+The module also contains \rou{tra\_ldf\_blp}, the subroutine calling twice \rou{tra\_ldf\_lap} in order to
 compute the iso-level bilaplacian operator.
 
-It is a \textit{horizontal} operator (\ie\ acting along geopotential surfaces) in
+It is a \textit{horizontal} operator (\ie acting along geopotential surfaces) in
 the $z$-coordinate with or without partial steps, but is simply an iso-level operator in the $s$-coordinate.
 It is thus used when, in addition to \np{ln\_traldf\_lap} or \np{ln\_traldf\_blp}\forcode{ = .true.},
@@ -614,8 +606,6 @@
 \label{subsec:TRA_ldf_triad}
 
-If the Griffies triad scheme is employed (\np{ln\_traldf\_triad}\forcode{ = .true.}; see \autoref{apdx:triad})
-
 An alternative scheme developed by \cite{griffies.gnanadesikan.ea_JPO98} which ensures tracer variance decreases
-is also available in \NEMO\ (\np{ln\_traldf\_grif}\forcode{ = .true.}).
+is also available in \NEMO\ (\np{ln\_traldf\_triad}\forcode{ = .true.}).
 A complete description of the algorithm is given in \autoref{apdx:triad}.
 
@@ -665,5 +655,5 @@
 respectively.
 Generally, $A_w^{vT} = A_w^{vS}$ except when double diffusive mixing is parameterised
-(\ie\ \texttt{zdfddm?} is defined).
+(\ie\ \np{ln\_zdfddm} equals \forcode{.true.},).
 The way these coefficients are evaluated is given in \autoref{chap:ZDF} (ZDF).
 Furthermore, when iso-neutral mixing is used, both mixing coefficients are increased by
@@ -677,11 +667,7 @@
 
 The large eddy coefficient found in the mixed layer together with high vertical resolution implies that
-in the case of explicit time stepping (\np{ln\_zdfexp}\forcode{ = .true.})
-there would be too restrictive a constraint on the time step.
-Therefore, the default implicit time stepping is preferred for the vertical diffusion since
+there would be too restrictive constraint on the time step if we use explicit time stepping.
+Therefore an implicit time stepping is preferred for the vertical diffusion since
 it overcomes the stability constraint.
-A forward time differencing scheme (\np{ln\_zdfexp}\forcode{ = .true.}) using
-a time splitting technique (\np{nn\_zdfexp} $> 1$) is provided as an alternative.
-Namelist variables \np{ln\_zdfexp} and \np{nn\_zdfexp} apply to both tracers and dynamics.
 
 % ================================================================
@@ -777,7 +763,7 @@
 
 Options are defined through the \nam{tra\_qsr} namelist variables.
-When the penetrative solar radiation option is used (\np{ln\_flxqsr}\forcode{ = .true.}),
+When the penetrative solar radiation option is used (\np{ln\_traqsr}\forcode{ = .true.}),
 the solar radiation penetrates the top few tens of meters of the ocean.
-If it is not used (\np{ln\_flxqsr}\forcode{ = .false.}) all the heat flux is absorbed in the first ocean level.
+If it is not used (\np{ln\_traqsr}\forcode{ = .false.}) all the heat flux is absorbed in the first ocean level.
 Thus, in the former case a term is added to the time evolution equation of temperature \autoref{eq:PE_tra_T} and
 the surface boundary condition is modified to take into account only the non-penetrative part of the surface
@@ -843,10 +829,10 @@
 
 \begin{description}
-\item[\np{nn\_chdta}\forcode{ = 0}]
+\item[\np{nn\_chldta}\forcode{ = 0}]
   a constant 0.05 g.Chl/L value everywhere ;
-\item[\np{nn\_chdta}\forcode{ = 1}]
+\item[\np{nn\_chldta}\forcode{ = 1}]
   an observed time varying chlorophyll deduced from satellite surface ocean color measurement spread uniformly in
   the vertical direction;
-\item[\np{nn\_chdta}\forcode{ = 2}]
+\item[\np{nn\_chldta}\forcode{ = 2}]
   same as previous case except that a vertical profile of chlorophyl is used.
   Following \cite{morel.berthon_LO89}, the profile is computed from the local surface chlorophyll value;
@@ -854,5 +840,5 @@
   simulated time varying chlorophyll by TOP biogeochemical model.
   In this case, the RGB formulation is used to calculate both the phytoplankton light limitation in
-  PISCES or LOBSTER and the oceanic heating rate.
+  PISCES and the oceanic heating rate.
 \end{description}
 
@@ -890,5 +876,5 @@
 %        Bottom Boundary Condition
 % -------------------------------------------------------------------------------------------------------------
-\subsection[Bottom boundary condition (\textit{trabbc.F90})]
+\subsection[Bottom boundary condition (\textit{trabbc.F90}) - \forcode{ln_trabbc = .true.})]
 {Bottom boundary condition (\protect\mdl{trabbc})}
 \label{subsec:TRA_bbc}
@@ -919,8 +905,8 @@
 (\ie\ the one associated with the Antarctic Bottom Water) by a few Sverdrups \citep{emile-geay.madec_OS09}.
 
-Options are defined through the \nam{tra\_bbc} namelist variables.
+Options are defined through the \nam{bbc} namelist variables.
 The presence of geothermal heating is controlled by setting the namelist parameter \np{ln\_trabbc} to true.
 Then, when \np{nn\_geoflx} is set to 1, a constant geothermal heating is introduced whose value is given by
-the \np{nn\_geoflx\_cst}, which is also a namelist parameter.
+the \np{rn\_geoflx\_cst}, which is also a namelist parameter.
 When \np{nn\_geoflx} is set to 2, a spatially varying geothermal heat flux is introduced which is provided in
 the \ifile{geothermal\_heating} NetCDF file (\autoref{fig:geothermal}) \citep{emile-geay.madec_OS09}.
@@ -1114,5 +1100,5 @@
 Options are defined through the  \nam{tra\_dmp} namelist variables.
 The restoring term is added when the namelist parameter \np{ln\_tradmp} is set to true.
-It also requires that both \np{ln\_tsd\_init} and \np{ln\_tsd\_tradmp} are set to true in
+It also requires that both \np{ln\_tsd\_init} and \np{ln\_tsd\_dmp} are set to true in
 \nam{tsd} namelist as well as \np{sn\_tem} and \np{sn\_sal} structures are correctly set
 (\ie\ that $T_o$ and $S_o$ are provided in input files and read using \mdl{fldread},
@@ -1175,5 +1161,5 @@
 Its default value is \np{rn\_atfp}\forcode{ = 10.e-3}.
 Note that the forcing correction term in the filter is not applied in linear free surface
-(\jp{lk\_vvl}\forcode{ = .false.}) (see \autoref{subsec:TRA_sbc}).
+(\jp{ln\_linssh}\forcode{ = .true.}) (see \autoref{subsec:TRA_sbc}).
 Not also that in constant volume case, the time stepping is performed on $T$, not on its content, $e_{3t}T$.
 
@@ -1199,7 +1185,8 @@
 %        Equation of State
 % -------------------------------------------------------------------------------------------------------------
-\subsection[Equation of seawater (\forcode{nn_eos = {-1,1}})]
-{Equation of seawater (\protect\np{nn\_eos}\forcode{ = {-1,1}})}
+\subsection[Equation of seawater (\texttt{ln}\{\texttt{\_teso10,\_eos80,\_seos}\})]
+{Equation of seawater (\protect\np{ln\_teos10}, \protect\np{ln\_teos80}, or \protect\np{ln\_seos}) }
 \label{subsec:TRA_eos}
+
 
 The Equation Of Seawater (EOS) is an empirical nonlinear thermodynamic relationship linking seawater density,
@@ -1218,5 +1205,5 @@
 \textit{(ii)}  it is more accurate, being based on an updated database of laboratory measurements, and
 \textit{(iii)} it uses Conservative Temperature and Absolute Salinity (instead of potential temperature and
-practical salinity for EOS-980, both variables being more suitable for use as model variables
+practical salinity for EOS-80, both variables being more suitable for use as model variables
 \citep{ioc.iapso_bk10, graham.mcdougall_JPO13}.
 EOS-80 is an obsolescent feature of the \NEMO\ system, kept only for backward compatibility.
@@ -1230,9 +1217,8 @@
 density in the World Ocean varies by no more than 2$\%$ from that value \citep{gill_bk82}.
 
-Options are defined through the \nam{eos} namelist variables, and in particular \np{nn\_eos} which
-controls the EOS used (\forcode{= -1} for TEOS10 ; \forcode{= 0} for EOS-80 ; \forcode{= 1} for S-EOS).
+Options which control the EOS used are defined through the \ngn{nameos} namelist variables.
 
 \begin{description}
-\item[\np{nn\_eos}\forcode{ = -1}]
+\item[\np{ln\_teos10}\forcode{ = .true.}]
   the polyTEOS10-bsq equation of seawater \citep{roquet.madec.ea_OM15} is used.
   The accuracy of this approximation is comparable to the TEOS-10 rational function approximation,
@@ -1250,8 +1236,8 @@
   In particular, the initial state deined by the user have to be given as \textit{Conservative} Temperature and
   \textit{Absolute} Salinity.
-  In addition, setting \np{ln\_useCT} to \forcode{.true.} convert the Conservative SST to potential SST prior to
+  In addition, when using TEOS10, the Conservative SST is converted to potential SST prior to
   either computing the air-sea and ice-sea fluxes (forced mode) or
   sending the SST field to the atmosphere (coupled mode).
-\item[\np{nn\_eos}\forcode{ = 0}]
+\item[\np{ln\_eos80}\forcode{ = .true.}]
   the polyEOS80-bsq equation of seawater is used.
   It takes the same polynomial form as the polyTEOS10, but the coefficients have been optimized to
@@ -1265,5 +1251,5 @@
   Nevertheless, a severe assumption is made in order to have a heat content ($C_p T_p$) which
   is conserved by the model: $C_p$ is set to a constant value, the TEOS10 value.
-\item[\np{nn\_eos}\forcode{ = 1}]
+\item[\np{ln\_seos}\forcode{ = .true.}]
   a simplified EOS (S-EOS) inspired by \citet{vallis_bk06} is chosen,
   the coefficients of which has been optimized to fit the behavior of TEOS10
@@ -1275,4 +1261,5 @@
   as well as between \textit{absolute} and \textit{practical} salinity.
   S-EOS takes the following expression:
+
   \begin{gather*}
     % \label{eq:tra_S-EOS}
@@ -1327,6 +1314,6 @@
 %        Brunt-V\"{a}is\"{a}l\"{a} Frequency
 % -------------------------------------------------------------------------------------------------------------
-\subsection[Brunt-V\"{a}is\"{a}l\"{a} frequency (\forcode{nn_eos = [0-2]})]
-{Brunt-V\"{a}is\"{a}l\"{a} frequency (\protect\np{nn\_eos}\forcode{ = [0-2]})}
+\subsection[Brunt-V\"{a}is\"{a}l\"{a} frequency]
+{Brunt-V\"{a}is\"{a}l\"{a} frequency}
 \label{subsec:TRA_bn2}
 